﻿<AML>
 <Item type="Method" id="0BE15BB3CD6C4595B11FC920C3C3A838" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			erp_pi_qty_update
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                Update Stock Original Qty in POP_PURCHASE_INVOICE_DETAILS  according by ID.

            Hooks:
                Type:		ItemType : pop_purchase_invoice
                Event:		Server Event ( onAfterAdd )
                
            Inputs:
                <describe the inputs expected by the server method>

            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "erp_pi_qty_update";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var _id = this.getID();
                var _pi_details_grid= myInnovator.newItem("POP_PURCHASE_INVOICE_DETAILS","get");
	            _pi_details_grid.setAttribute("select","id,source_id,stk_code,stk_qty,update_id,stk_ori_qty");
	            _pi_details_grid.setProperty("source_id", _id);
	            _pi_details_grid.setPropertyCondition("source_id","eq");
	            _pi_details_grid = _pi_details_grid.apply(); 
	            var _pi_details_grid_count = _pi_details_grid.getItemCount();
	            if(_pi_details_grid_count>0)
	            {
	                for(var i=0;i<_pi_details_grid_count;i++)
		            {
		                var _pi_det_data = _pi_details_grid.getItemByIndex(i);
				        var _details_id = _pi_det_data.getProperty("id","");
				        var _qty = _pi_det_data.getProperty("stk_qty","");
				        Item _pi_update_details = myInnovator.applySQL("Update innovator.[POP_PURCHASE_INVOICE_DETAILS] set stk_ori_qty="+_qty+",update_id='"+_details_id+"' where id='"+_details_id+"'");	   
		            }
	            }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }
]]></method_code>
  <method_type>C#</method_type>
  <name>erp_pi_qty_update</name>
 </Item>
</AML>